#ifndef ASPEN_DEVEL_FUNC_H_INCLUDED

#include "aspen_types.h"

#define WSYMV_args                              \
  ( const int blk,				\
    const int n,                                \
    const cuddreal * a, const int lda,		\
    const cuddreal * x, const int incx,         \
    cuddreal * y, const int incy,               \
    const cuddreal alpha, const cuddreal beta )

extern "C"void API(WSYMVu) WSYMV_args;
extern "C"void API(WSYMVl) WSYMV_args;
extern "C"void API_private(WSYMVu_STUB) WSYMV_args;
extern "C"void API_private(WSYMVl_STUB) WSYMV_args;


#define DSYMV_args                              \
  ( const int blk,				\
    const int n,                                \
    const double * a, const int lda,		\
    const double * x, const int incx,           \
    double * y, const int incy,                 \
    const double alpha, const double beta )

extern "C"void API(DSYMVu) DSYMV_args;
extern "C"void API(DSYMVl) DSYMV_args;
extern "C"void API_private(DSYMVu_STUB) DSYMV_args;
extern "C"void API_private(DSYMVl_STUB) DSYMV_args;


#define SSYMV_args                              \
  ( const int blk,                              \
    const int n,				\
    const float * a, const int lda,             \
    const float * x, const int incx,            \
    float * y, const int incy,                  \
    const float alpha, const float beta )

extern "C"void API(SSYMVu) SSYMV_args;
extern "C"void API(SSYMVl) SSYMV_args;
extern "C"void API_private(SSYMVu_STUB) SSYMV_args;
extern "C"void API_private(SSYMVl_STUB) SSYMV_args;


#define UHEMV_args                                      \
  ( const int blk,                                      \
    const int n,                                        \
    const cuddcomplex * a, const int lda,               \
    const cuddcomplex * x, const int incx,              \
    cuddcomplex * y, const int incy,                    \
    const cuddcomplex alpha, const cuddcomplex beta )

extern "C"void API(UHEMVu) UHEMV_args;
extern "C"void API(UHEMVl) UHEMV_args;
extern "C"void API_private(UHEMVu_STUB) UHEMV_args;
extern "C"void API_private(UHEMVl_STUB) UHEMV_args;


#define ZHEMV_args                                              \
  ( const int blk,                                              \
    const int n,                                                \
    const cuDoubleComplex * a, const int lda,                   \
    const cuDoubleComplex * x, const int incx,                  \
    cuDoubleComplex * y, const int incy,                        \
    const cuDoubleComplex alpha, const cuDoubleComplex beta )

extern "C"void API(ZHEMVu) ZHEMV_args;
extern "C"void API(ZHEMVl) ZHEMV_args;
extern "C"void API_private(ZHEMVu_STUB) ZHEMV_args;
extern "C"void API_private(ZHEMVl_STUB) ZHEMV_args;


#define CHEMV_args                                              \
  ( const int blk,                                              \
    const int n,                                                \
    const cuFloatComplex * a, const int lda,                    \
    const cuFloatComplex * x, const int incx,                   \
    cuFloatComplex * y, const int incy,                         \
    const cuFloatComplex alpha, const cuFloatComplex beta )

extern "C"void API(CHEMVu) CHEMV_args;
extern "C"void API(CHEMVl) CHEMV_args;
extern "C"void API_private(CHEMVu_STUB) CHEMV_args;
extern "C"void API_private(CHEMVl_STUB) CHEMV_args;


#define ASPEN_DEVEL_FUNC_H_INCLUDED	1
#endif

