#include "float.h"
#include "aspen_devel.h"


extern "C" void
API(ssymv) ( const char uplo, const int n,
	     const scalar_t alpha,
	     const scalar_t * a, const int lda,
	     const scalar_t * x, const int incx,
	     const scalar_t beta,
	     scalar_t * y, const int incy )
{
  if ( n <= 0 ) return;
  if ( incy == 0 ) return;

  if ( alpha == makeCONST<scalar_t>(0) ) {
    if ( beta == makeCONST<scalar_t>(1) ) return;
    if ( beta == makeCONST<scalar_t>(0) && incy == 1 ) {
      API(SZERO) ( y, n );
    } else {
      API(sscal) ( n, beta, y, incy );
    }
    return;
  }

  int upper = (uplo=='U')||(uplo=='u');
  int lower = (uplo=='L')||(uplo=='l');
  if ( upper ) {
    API(SSYMVu) ( -1, n, a, lda, x, incx, y, incy, alpha, beta );
  } else if ( lower ) {
    API(SSYMVl) ( -1, n, a, lda, x, incx, y, incy, alpha, beta );
  } else {
    // error
  }
}

