#if !defined(CURRENT_GPU)
#  include "../tuning/CURRENT_GPU"
#endif
#if !defined(GPU_ARCH)
#  define GPU_ARCH	CURRENT_GPU
#endif

#include "float.h"
#include "aspen_devel.h"

#include "ssymv_lower-X_template.cu"

extern "C" void
API(SSYMVl) ( const int blk,
              const int n, const scalar_t * a, const int lda,
              const scalar_t * x, const int incx,
              scalar_t * y, const int incy,
              const scalar_t alpha, const scalar_t beta )
{

  // y = alpha * A * x + beta * y
  // y(1:n1)
  // x(1:n2)

  int Ver = API(get_device_CC) ( );

  if ( CURRENT_GPU == Ver ) {
    API_private(SSYMVl_STUB) ( blk,
                               n, a, lda, x, incx, y, incy, alpha, beta );
  } else {
    perror( "unmatched GPU generation" ); /* unmatched */
  }

}

