#if 0
__forceinline__ __device__ void
get_Ticket_x ( int * Ticket, const int X, const int is_master, const int block_id )
{
  if ( is_master ) {
    int i;
    for ( i = 0; i < 1000000; ++i ) {
      // const int T = gridDim.x;
      const int T = -1;
      if ( atomicCAS( Ticket, block_id, T ) == block_id ) break;
      int j;
      for ( j = 0; j < 100000; j++) {
        __LOOP_DIVIDER__();
      }
    }
    if ( i < 1000000 ) { ; } else {
      printf("Over-time to get Ticket (%d) by %d\n", X, block_id);
    }
  }
  __syncthreads ( );
}
#endif

__forceinline__ __device__ void
get_Ticket ( int * Ticket, const int is_master, const int block_id )
{
  if ( is_master ) {
    while ( 1 ) {
      // const int T = gridDim.x;
      const int T = -1;
      if ( atomicCAS( Ticket, block_id, T ) == block_id ) break;
    }
  }
  __syncthreads ( );
}

#if 0
__forceinline__ __device__ void
release_Ticket_x ( int * Ticket, const int X, const int is_master, const int next_block_id )
{
  __syncthreads ( );
  if ( is_master ) {
    const int T = next_block_id;
    atomicExch ( Ticket, T );
    { 
      printf("Released get Ticket (%d) to %d\n", X, next_block_id);
    }
  }
}
#endif

__forceinline__ __device__ void
release_Ticket ( int * Ticket, const int is_master, const int next_block_id )
{
  __syncthreads ( );
  if ( is_master ) {
    const int T = next_block_id;
    atomicExch ( Ticket, T );
  }
}

__forceinline__ __device__ void
skip_Ticket ( int * Ticket, const int is_master, const int block_id, const int next_block_id )
{
  if ( is_master ) {
    while ( 1 ) {
      const int T = next_block_id;
      if ( atomicCAS( Ticket, block_id, T ) == block_id ) break;
    }
  }
  __syncthreads ( );
}

__forceinline__ __device__ void
wait_for_Ticket ( int * Ticket, const int is_master, const int T )
{
  if ( is_master ) {
    while ( 1 ) {
      if ( atomicOr( Ticket, 0 ) == T ) break;
    }
  }
  __syncthreads ( );
}

__forceinline__ __device__ int
look_at_Ticket_Value ( int * Ticket, const int is_master, int * sh_mem )
{
  __syncthreads ( );
  if ( is_master ) {
    *sh_mem = atomicOr( Ticket, 0 );
  }
  __syncthreads ( ); int ret = *sh_mem; __syncthreads ( );
  return ret;
}


