#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV-L
Mon Dec 18 06:10:53 JST 2017
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-1080
****************************************/-->
// device name
DEVICE= GeForce-GTX-1080
// the number of multi-processors
MP= 20
// compute-compatibility generation
CG= 610
// capacity of the global memory
MAXmem= 8507883776
// for double or cuFloatComplex
MAXDIM= 30980
// for float
MAXDIM2= 43813
// for cuDoubleComplex or DD
MAXDIM3= 21906
// for DD-Complex
MAXDIM4= 15490
// cuda version
CUDA= 8000
<--
#define CURRENT_GPU 610
-->
#endif
{
//==========
if(blk==-1){
	#include "ssymv-lower-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 64, 6, 3, 69, 4, 20 },
	{ 64, 8, 3, 69, 4, 20 },
	{ 64, 4, 5, 65, 3, 20 },
	{ 64, 5, 3, 69, 4, 20 },
	{ 64, 1, 3, 69, 4, 20 },
	{ 64, 4, 3, 69, 4, 20 },
	{ 64, 2, 3, 69, 4, 20 },
	{ 64, 7, 5, 65, 3, 20 },
	{ 64, 8, 2, 36, 7, 20 },
	{ 64, 5, 5, 65, 3, 0 },
	{ 64, 3, 2, 36, 7, 20 },
	{ 64, 6, 4, 48, 4, 20 },
	{ 64, 8, 5, 65, 3, 30 },
	{ 64, 5, 5, 65, 3, 30 },
	{ 64, 3, 3, 69, 4, 20 },
	{ 64, 7, 3, 69, 4, 20 },
	{ 64, 1, 2, 36, 7, 20 },
	{ 64, 4, 2, 36, 7, 20 },
	{ 64, 5, 2, 36, 7, 20 },
	{ 64, 2, 2, 36, 7, 20 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 6, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 8, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 5, 65, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 1, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 7, 5, 65, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 8, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 5, 65, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 6, 4, 48, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 8, 5, 65, 3, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 5, 65, 3, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 7, 3, 69, 4, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 1, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 2, 36, 7, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
