#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV-L
Thu Dec 21 17:49:25 JST 2017
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
// device name
DEVICE= GeForce-GTX-750-Ti
// the number of multi-processors
MP= 5
// compute-compatibility generation
CG= 500
// capacity of the global memory
MAXmem= 2094400256
// for double or cuFloatComplex
MAXDIM= 15371
// for float
MAXDIM2= 21738
// for cuDoubleComplex or DD
MAXDIM3= 10869
// for DD-Complex
MAXDIM4= 7685
// cuda version
CUDA= 8000
<--
#define CURRENT_GPU 500
-->
#endif
{
//==========
if(blk==-1){
	#include "ssymv-lower-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 5, 4, 92, 6, 30 },
	{ 32, 6, 4, 92, 6, 20 },
	{ 32, 8, 4, 92, 6, 30 },
	{ 32, 7, 4, 92, 6, 20 },
	{ 32, 7, 4, 92, 6, 30 },
	{ 32, 4, 4, 92, 6, 30 },
	{ 32, 4, 4, 92, 6, 20 },
	{ 32, 1, 4, 92, 6, 20 },
	{ 64, 5, 6, 66, 3, 20 },
	{ 64, 7, 6, 66, 3, 20 },
	{ 32, 8, 4, 88, 6, 20 },
	{ 32, 8, 4, 60, 8, 20 },
	{ 32, 1, 4, 60, 8, 20 },
	{ 32, 2, 4, 92, 6, 30 },
	{ 32, 1, 4, 92, 6, 30 },
	{ 32, 6, 4, 92, 6, 30 },
	{ 32, 3, 4, 92, 6, 30 },
	{ 32, 3, 4, 92, 6, 20 },
	{ 32, 2, 4, 92, 6, 20 },
	{ 32, 8, 4, 92, 6, 20 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 5, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 6, 66, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 7, 6, 66, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 88, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 60, 8, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 60, 8, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 3, 4, 92, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 3, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 92, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
