#if 0
<--/****************************************
Automatic Performance Tuning for WSYMV-U
Tue Dec 19 15:52:37 JST 2017
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-750-Ti
****************************************/-->
// device name
DEVICE= GeForce-GTX-750-Ti
// the number of multi-processors
MP= 5
// compute-compatibility generation
CG= 500
// capacity of the global memory
MAXmem= 2094400256
// for double or cuFloatComplex
MAXDIM= 15371
// for float
MAXDIM2= 21738
// for cuDoubleComplex or DD
MAXDIM3= 10869
// for DD-Complex
MAXDIM4= 7685
// cuda version
CUDA= 9000
<--
#define CURRENT_GPU 500
-->
#endif
{
//==========
if(blk==-1){
	#include "wsymv-upper-auto2.h"
}
//==========
#if 0
struct wsymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 1, 4, 48, 3, 20 },
	{ 32, 2, 4, 52, 3, 20 },
	{ 32, 3, 2, 26, 6, 20 },
	{ 32, 1, 4, 52, 3, 20 },
	{ 32, 1, 4, 48, 3, 0 },
	{ 32, 1, 4, 52, 3, 0 },
	{ 32, 1, 4, 44, 3, 0 },
	{ 32, 2, 4, 44, 3, 20 },
	{ 32, 4, 2, 22, 6, 20 },
	{ 32, 2, 4, 48, 3, 20 },
	{ 32, 2, 2, 24, 6, 20 },
	{ 32, 2, 4, 44, 3, 0 },
	{ 32, 2, 2, 26, 6, 30 },
	{ 32, 3, 2, 26, 6, 0 },
	{ 32, 2, 2, 24, 6, 30 },
	{ 32, 2, 2, 26, 6, 10 },
	{ 32, 2, 4, 52, 3, 0 },
	{ 32, 2, 2, 24, 6, 10 },
	{ 32, 2, 1, 1, 1, 1 },
	{ 32, 2, 1, 1, 1, 1 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 48, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 52, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 3, 2, 26, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 52, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 48, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 52, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 44, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 44, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 2, 22, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 48, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 2, 24, 6, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 44, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 2, 26, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 3, 2, 26, 6, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 2, 24, 6, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 2, 26, 6, 10 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 52, 3, 0 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 2, 24, 6, 10 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 1, 1, 1, 1 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 1, 1, 1, 1 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
