#if 0
<--/****************************************
Automatic Performance Tuning for CHEMV-U
Tue Dec 26 08:40:09 JST 2017
Host on newton.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
// device name
DEVICE= GeForce-GTX-980
// the number of multi-processors
MP= 16
// compute-compatibility generation
CG= 520
// capacity of the global memory
MAXmem= 4234096128
// for double or cuFloatComplex
MAXDIM= 21855
// for float
MAXDIM2= 30908
// for cuDoubleComplex or DD
MAXDIM3= 15454
// for DD-Complex
MAXDIM4= 10927
// cuda version
CUDA= 8000
<--
#define CURRENT_GPU 520
-->
#endif
{
//==========
if(blk==-1){
	#include "chemv-upper-auto2.h"
}
//==========
#if 0
struct chemv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 64, 3, 4, 80, 2, 20 },
	{ 32, 7, 4, 80, 4, 70 },
	{ 64, 3, 5, 65, 2, 20 },
	{ 64, 4, 4, 80, 2, 20 },
	{ 64, 5, 4, 76, 2, 20 },
	{ 64, 2, 4, 76, 2, 20 },
	{ 64, 2, 5, 65, 2, 20 },
	{ 32, 4, 4, 52, 5, 30 },
	{ 64, 3, 3, 39, 3, 20 },
	{ 64, 2, 5, 60, 2, 30 },
	{ 32, 2, 4, 80, 4, 70 },
	{ 32, 2, 4, 52, 5, 30 },
	{ 32, 5, 4, 52, 5, 30 },
	{ 64, 4, 4, 76, 2, 20 },
	{ 32, 6, 4, 80, 4, 70 },
	{ 32, 8, 4, 80, 4, 70 },
	{ 32, 7, 4, 52, 5, 30 },
	{ 32, 5, 4, 80, 4, 70 },
	{ 64, 5, 4, 80, 2, 20 },
	{ 64, 2, 4, 80, 2, 20 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 4, 80, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 80, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 5, 65, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 4, 80, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 4, 76, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 4, 76, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 5, 65, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 52, 5, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 3, 39, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 5, 60, 2, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 80, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 52, 5, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 5, 4, 52, 5, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 4, 76, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 80, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 80, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 52, 5, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 5, 4, 80, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 5, 4, 80, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 4, 80, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
