#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV-U
Sat Dec  9 23:21:14 JST 2017
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
// device name
DEVICE= GeForce-GTX-TITAN-Black
// the number of multi-processors
MP= 15
// compute-compatibility generation
CG= 350
// capacity of the global memory
MAXmem= 6377540096
// for double or cuFloatComplex
MAXDIM= 26822
// for float
MAXDIM2= 37933
// for cuDoubleComplex or DD
MAXDIM3= 18966
// for DD-Complex
MAXDIM4= 13411
// cuda version
CUDA= 9000
<--
#define CURRENT_GPU 350
-->
#endif
{
//==========
if(blk==-1){
	#include "ssymv-upper-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 64, 3, 3, 48, 5, 20 },
	{ 32, 2, 4, 48, 9, 70 },
	{ 32, 2, 6, 72, 6, 70 },
	{ 64, 2, 3, 48, 5, 20 },
	{ 64, 4, 3, 48, 5, 20 },
	{ 96, 2, 3, 36, 4, 60 },
	{ 64, 1, 4, 56, 4, 60 },
	{ 32, 2, 4, 60, 8, 60 },
	{ 64, 4, 4, 56, 4, 60 },
	{ 64, 3, 5, 45, 4, 30 },
	{ 32, 4, 4, 56, 8, 20 },
	{ 64, 3, 4, 56, 4, 60 },
	{ 64, 1, 3, 48, 5, 20 },
	{ 96, 2, 3, 36, 4, 70 },
	{ 32, 6, 4, 48, 9, 70 },
	{ 32, 2, 4, 56, 8, 60 },
	{ 32, 2, 4, 60, 8, 70 },
	{ 96, 4, 4, 48, 3, 20 },
	{ 64, 6, 5, 45, 4, 30 },
	{ 32, 6, 6, 72, 6, 70 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 3, 48, 5, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 48, 9, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 6, 72, 6, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 2, 3, 48, 5, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 3, 48, 5, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 96, 2, 3, 36, 4, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 1, 4, 56, 4, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 60, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 4, 56, 4, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 5, 45, 4, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 56, 8, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 3, 4, 56, 4, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 1, 3, 48, 5, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 96, 2, 3, 36, 4, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 48, 9, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 56, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 60, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 96, 4, 4, 48, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 6, 5, 45, 4, 30 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVu_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 6, 72, 6, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
