#if 0
<--/****************************************
Automatic Performance Tuning for SSYMV-L
Fri Dec 15 12:59:05 JST 2017
Host on gwacsg01
Device is Tesla-K20Xm
****************************************/-->
// device name
DEVICE= Tesla-K20Xm
// the number of multi-processors
MP= 14
// compute-compatibility generation
CG= 350
// capacity of the global memory
MAXmem= 5975680512
// for double or cuFloatComplex
MAXDIM= 25964
// for float
MAXDIM2= 36718
// for cuDoubleComplex or DD
MAXDIM3= 18359
// for DD-Complex
MAXDIM4= 12982
// cuda version
CUDA= 8000
<--
#define CURRENT_GPU 350
-->
#endif
{
//==========
if(blk==-1){
	#include "ssymv-lower-auto2.h"
}
//==========
#if 0
struct ssymv_auto_tuning_param_t { 
	int	BLOCK_SIZE, GY, VX, UX, MULTI, MX; 
} PARAM[22] = {
	{ 32, 4, 4, 48, 8, 60 },
	{ 32, 6, 4, 48, 8, 60 },
	{ 32, 7, 4, 48, 8, 60 },
	{ 32, 8, 4, 48, 8, 60 },
	{ 32, 2, 4, 48, 8, 70 },
	{ 32, 8, 4, 48, 8, 70 },
	{ 96, 8, 4, 64, 2, 20 },
	{ 96, 7, 4, 60, 2, 20 },
	{ 64, 8, 5, 45, 3, 20 },
	{ 64, 6, 4, 64, 3, 10 },
	{ 64, 4, 4, 64, 3, 10 },
	{ 64, 8, 4, 40, 4, 60 },
	{ 32, 5, 4, 40, 8, 60 },
	{ 32, 3, 4, 48, 8, 60 },
	{ 32, 1, 4, 48, 8, 70 },
	{ 32, 7, 4, 48, 8, 70 },
	{ 32, 1, 4, 48, 8, 60 },
	{ 32, 2, 4, 48, 8, 60 },
	{ 32, 4, 4, 48, 8, 70 },
	{ 32, 6, 4, 48, 8, 70 },
	{ 0, 0, 0, 0, 0, 0 }
};
#endif
//==========
switch ( BLK ) {
#if KERNEL_1
case 1:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_2
case 2:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_3
case 3:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_4
case 4:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_5
case 5:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_6
case 6:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 8, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_7
case 7:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 96, 8, 4, 64, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_8
case 8:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 96, 7, 4, 60, 2, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_9
case 9:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 8, 5, 45, 3, 20 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_10
case 10:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 6, 4, 64, 3, 10 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_11
case 11:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 4, 4, 64, 3, 10 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_12
case 12:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 64, 8, 4, 40, 4, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_13
case 13:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 5, 4, 40, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_14
case 14:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 3, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_15
case 15:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_16
case 16:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 7, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_17
case 17:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 1, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_18
case 18:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 2, 4, 48, 8, 60 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_19
case 19:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 4, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
#if KERNEL_20
case 20:
	API_private(HESYMVl_ATOMIC__host) < GPU_ARCH, scalar_t, 32, 6, 4, 48, 8, 70 >
		( n, a, lda, x, incx, y, incy, alpha, beta ); break;
#endif
default:
	break;
}
//==========
}
